Issue #9381 has been updated by Tomoyuki Chikanaga.

Backport changed from 1.9.3: DONTNEED, 2.0.0: DONTNEED, 2.1: DONE to 1.9.3: DONTNEED, 2.0.0: DONTNEED, 2.1: REQUIRED, 2.2: REQUIRED

I re-fill Backport field for r51425. I'm not sure if this is bugfix or feature change though.

----------------------------------------
Bug #9381: 2.1.0 Regression. Hash lookup with #hash and #eql?
https://bugs.ruby-lang.org/issues/9381#change-53599

* Author: Nick S
* Status: Closed
* Priority: Normal
* Assignee: Nobuyoshi Nakada
* ruby -v: ruby 2.1.0p0 (2013-12-25 revision 44422) [x86_64-linux]
* Backport: 1.9.3: DONTNEED, 2.0.0: DONTNEED, 2.1: REQUIRED, 2.2: REQUIRED
----------------------------------------
Ruby 2.1.0 won't fetch objects when the lookup key overrides `#hash` and `#eql?`.
This is a regression as it works as expected in ruby 1.8, 1.9 and 2.0.

```ruby
class Wrapper
  def initialize(obj)
    @obj = obj
  end

  def method_missing(symbol, *args, &block)
    @obj.__send__(symbol, *args, &block)
  end

  def hash
    @obj.hash
  end

  def eql?(other)
    @obj.eql?(other)
  end
end

hash = { 5 => "LOOKUP SUCCEEDED" }

# Prints "LOOKUP SUCCEEDED" on RUBY < 2.1.0. Fails on RUBY 2.1.0.
p hash[Wrapper.new(5)]
```




-- 
https://bugs.ruby-lang.org/